CON

_CLKMODE = XTAL1 + PLL16X
_XINFREQ = 5_000_000

'Pins.
transmitPin = 19 'Stores the pin the serial transmitter is connected to.
recievePin = 20 'Stores the pin the serial reciever is connected to.
TXRX = 16 'Stores the pin that switches between transmit and recieve mode.

'Constants.
serialMode = %1100 'Stores the serial data mode.
baudRate = 9600 'Stores the serial baud rate.

OBJ

SER        : "FullDuplexSerial.Spin"

PUB Main

SER.Start(transmitPin, recievePin, serialMode, baudRate) 'Start the serial transmitter. 

PUB TransmitByte(txbyte)

'Put Transciever into transmit mode.
dira[TXRX]~~
outa[TXRX]~~

'Transmit the data.
repeat
  'Transmit the byte
  SER.TX(txbyte)
  'Transmit the Calculated CRC
  SER.TX(CalcCRCValue(txbyte))

PUB RecieveByte | buffer

'Put Transciever into recieve mode.
dira[TXRX]~~
outa[TXRX]~

'Recieve the byte
repeat
  buffer := SER.RX
  
  '******** Validate the CRC, if it is good, transmit a * back to the origin. ********

  'Put the recieved values on the LEDs.
  buffer := outa[12..15] 

PUB CalcCRCValue(data)

'How do you calculate the CRC?